﻿Public Class QuestionForm
    Private NewColor As Integer = 0 'кодирует цвет, выбранный пользователем
    Private vDecFrom As Integer = MainForm.numDecFrom.Value 'индекс начала пропоганенного участка
    Private vDecTo As Integer = MainForm.numDecTo.Value 'индекс конца пропоганенного участка
    Private Sub QuestionForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim UBaROM As Integer = aROM.GetUpperBound(0)
        If vDecTo = UBaROM Then
            rb1.Visible = False
            num1.Visible = False
            lb1.Visible = False
            num1.Maximum = qfnum1
            num1.Value = qfnum1
            If qfrb = 1 Then qfrb = 4
        ElseIf qfnum1 <= UBaROM - vDecTo Then
            num1.Maximum = UBaROM - vDecTo
            num1.Value = qfnum1
        Else
            num1.Maximum = UBaROM - vDecTo
            num1.Value = num1.Maximum
        End If
        If vDecFrom = 0 Then
            rb2.Visible = False
            num2.Visible = False
            lb2.Visible = False
            num2.Maximum = qfnum2
            num2.Value = qfnum2
            If qfrb = 2 Then qfrb = 4
        ElseIf qfnum2 <= vDecFrom Then
            num2.Maximum = vDecFrom
            num2.Value = qfnum2
        Else
            num2.Maximum = vDecFrom
            num2.Value = vDecFrom
        End If

        Choose(qfrb, rb1, rb2, rb3, rb4).checked = True
        If qfHex Then
            rbHex.Checked = True
        Else
            rbDec.Checked = True
            num1.Increment = MainForm.numDecFrom.Increment
            num2.Increment = num1.Increment
        End If
        chb1.Checked = qfReconstruction

        lbNews.Text = "Изменён интервал с " & MainForm.numHexFrom.Text & " h (" & vDecFrom.ToString & " d) по " & _
         MainForm.numHexTo.Text & " h (" & vDecTo.ToString & " d) файла" & vbCrLf & myFileName & vbCrLf & _
        "(индекс последнего байта " & Hex(UBaROM) & " h (" & UBaROM.ToString & " d)"
    End Sub

    Private Sub rbHex_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbHex.CheckedChanged
        If rbHex.Checked Then
            num1.Hexadecimal = True
            num2.Hexadecimal = True
            lb1.Text = "h"
            lb2.Text = "h"
            num1.Increment = MainForm.numHexFrom.Increment
        Else
            num1.Hexadecimal = False
            num2.Hexadecimal = False
            lb1.Text = "d"
            lb2.Text = "d"
            num1.Increment = MainForm.numDecFrom.Increment
        End If
        num2.Increment = num1.Increment
    End Sub
    Private Sub rbsAddress_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rb1.CheckedChanged, rb2.CheckedChanged, rb3.CheckedChanged, rb4.CheckedChanged
        If rb1.Checked Then
            num1.Enabled = True
            num2.Enabled = False
            num1.Focus()
        ElseIf rb2.Checked Then
            num1.Enabled = False
            num2.Enabled = True
            num2.Focus()
        ElseIf rb3.Checked Then
            num1.Enabled = False
            num2.Enabled = False
        Else
            num1.Enabled = False
            num2.Enabled = False
        End If
    End Sub
    
    Private Sub btnBlue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBlue.Click
        NewColor = 1
        Me.Close()
    End Sub
    Private Sub btnGreen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGreen.Click
        NewColor = 2
        Me.Close()
    End Sub
    Private Sub btnRed_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRed.Click
        NewColor = 3
        Me.Close()
    End Sub
    Private Sub btnYellow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYellow.Click
        NewColor = 4
        Me.Close()
    End Sub
    Private Sub btnGrey_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrey.Click
        NewColor = 5
        Me.Close()
    End Sub
    Private Sub btnNone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNone.Click
        Me.Close()
    End Sub

    Private Sub QuestionForm_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        If NewColor <> 0 Then 'Если не нажата кнопка отмены
            Dim aNew(aDiag.GetUpperBound(0) + 4) As Integer
            Dim j As Integer = 0
            Dim bWriteNone As Boolean = True
            Dim i As Integer
            'Создание вспомогательного массива
            For i = 2 To aDiag.GetUpperBound(0) Step 2
                If aDiag(i) < vDecFrom Then
                    aNew(j + 1) = aDiag(i - 1)
                    aNew(j + 2) = aDiag(i)
                    j += 2
                ElseIf bWriteNone Then
                    If vDecFrom <> 0 Then
                        aNew(j + 1) = aDiag(i - 1)
                        aNew(j + 2) = vDecFrom
                        j += 2
                    End If
                    aNew(j + 1) = NewColor
                    aNew(j + 2) = vDecTo + 1
                    j += 2
                    i -= 2
                    bWriteNone = False
                ElseIf aDiag(i) > vDecTo + 1 Then
                    aNew(j + 1) = aDiag(i - 1)
                    aNew(j + 2) = aDiag(i)
                    j += 2
                End If
            Next
            'Слияния двух соприкасающихся одноцветных диапазонов
            ReDim aDiag(aNew.GetUpperBound(0))
            aDiag(0) = 0
            aDiag(1) = aNew(1)
            aDiag(2) = aNew(2)
            Dim idiag As Integer = 2
            For i = 3 To j - 1 Step 2
                If aNew(i) = aDiag(idiag - 1) Then
                    aDiag(idiag) = aNew(i + 1)
                Else
                    aDiag(idiag + 1) = aNew(i)
                    aDiag(idiag + 2) = aNew(i + 1)
                    idiag += 2
                End If
            Next
            ReDim Preserve aDiag(idiag)
        End If

        'Сохранение настроек
        qfnum1 = num1.Value
        qfnum2 = num2.Value
        If rb1.Checked Then
            qfrb = 1
        ElseIf rb2.Checked Then
            qfrb = 2
        ElseIf rb3.Checked Then
            qfrb = 3
        Else
            qfrb = 4
        End If
        qfReconstruction = chb1.Checked
        If rbHex.Checked Then
            qfHex = True
        Else
            qfHex = False
        End If
    End Sub
End Class