﻿Public Class SecondaryForm
    Private Sub SecondaryForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If bCycle Then
            rbCycle.Checked = True
        Else
            rbFreeze.Checked = True
        End If

        If bRAM Then
            rbRAM.Checked = True
        Else
            rbROM.Checked = True
        End If

        Select Case MainForm.numDecFrom.Increment
            Case 1 : rbStep1.Checked = True
            Case 10 : rbStep10.Checked = True
            Case 100 : rbStep100.Checked = True
            Case 1000 : rbStep1000.Checked = True
            Case 10000 : rbStep10000.Checked = True
            Case 100000 : rbStep100000.Checked = True
        End Select
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.Close()
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        bCycle = rbCycle.Checked
        bRAM = rbRAM.Checked
        If rbStep1.Checked Then
            MainForm.numDecFrom.Increment = 1
            MainForm.numHexFrom.Increment = 1
        ElseIf rbStep10.Checked Then
            MainForm.numDecFrom.Increment = 10
            MainForm.numHexFrom.Increment = 16
        ElseIf rbStep100.Checked Then
            MainForm.numDecFrom.Increment = 100
            MainForm.numHexFrom.Increment = 256
        ElseIf rbStep1000.Checked Then
            MainForm.numDecFrom.Increment = 1000
            MainForm.numHexFrom.Increment = 4096
        ElseIf rbStep10000.Checked Then
            MainForm.numDecFrom.Increment = 10000
            MainForm.numHexFrom.Increment = 65536
        ElseIf rbStep100000.Checked Then
            MainForm.numDecFrom.Increment = 100000
            MainForm.numHexFrom.Increment = 1048576
        End If
        MainForm.numDecTo.Increment = MainForm.numDecFrom.Increment
        MainForm.numHexTo.Increment = MainForm.numHexFrom.Increment
        Me.Close()
    End Sub
End Class